#!/usr/bin/python


############################################################
#
# send IM from command line to fuzzy pidgin friends via dbus
#
# usage:
#          im.py "jadi" "hello friend"
#
# version: 0.8 
# published under GPL3
#
# Jadijadi@gmail.com, www.freekeyboard.net, www.jadi.net
#
############################################################

import sys, dbus, gobject, difflib, fuzzywuzzy;
from fuzzywuzzy import fuzz
from fuzzywuzzy import process

foundName = ''
foundAlias = ''
foundMaxRatio = 0

bus = dbus.SessionBus()
obj = bus.get_object("im.pidgin.purple.PurpleService", "/im/pidgin/purple/PurpleObject")
purple = dbus.Interface(obj, "im.pidgin.purple.PurpleInterface")

for thisAccount in purple.PurpleAccountsGetAllActive():
	myname = purple.PurpleAccountGetUsername (thisAccount)
	for buddy in purple.PurpleFindBuddies(thisAccount, '' ):
		try:
			alias = purple.PurpleBuddyGetAlias (buddy)
			username = purple.PurpleBuddyGetName (buddy)
			if fuzz.partial_ratio (username, sys.argv[1]) > foundMaxRatio:
				foundName = username
				foundAlias = alias
				foundMaxRatio = fuzz.partial_ratio (username, sys.argv[1])

			if fuzz.partial_ratio (alias, sys.argv[1]) > foundMaxRatio:
				foundName = username
				foundAlias = alias
				foundMaxRatio = fuzz.partial_ratio (username, sys.argv[1])
		except:
			print 

if (username):

		print 'Send \'', sys.argv[2], '\' to ', foundAlias, '(', foundName, ')', '? ', 
		if sys.stdin.readline() == "y\n":
			thisConv = purple.PurpleConversationNew(1, thisAccount, foundName)
			purple.PurpleConvImSend (purple.PurpleConvIm(thisConv), sys.argv[2])

